<?php
/*
* Project:     Morgdkp2 eqdkp plus plug-in
* License:     Creative Commons - Attribution-Noncommercial-Share Alike 3.0 Unported
* Link:    http://creativecommons.org/licenses/by-nc-sa/3.0/
* -----------------------------------------------------------------------
* Began:       2013
* -----------------------------------------------------------------------
* @author      BlueWarlord
* @copyright   2013-
* Based upon the EQdkp-Plus epgpimport plug-in and Morgalm's original morgdkp 2 plug-in for eqkdp plus 0.6
*/


if(!defined('EQDKP_INC')) {
	header('HTTP/1.0 Not Found');
	exit;
}
$eqdkp_root_path = './../../../';
include_once($eqdkp_root_path.'common.php');

if(!class_exists('morgdkp2_parser')) {
	class morgdkp2_parser extends gen_class {
		public static $shortcuts = array('in', 'pdh', 'user', 'config', 'time');
		public $webversion;  
		public $Switches, $newalts, $needchanged, $RAID, $DKP;
		private $pdl;
		private $func;                                                 
		
		public function __construct() {
			$_SESSION['passalts'] = "";
			$_SESSION['dkpchange'] = "";
			$_SESSION['RAID'] = "";
			$this->webversion = "3.3";
			$this->DKP = array();
			$this->RAID = array();
			$this->Switches = array();
			$this->newalts = array();
			$this->needchanged = array();
			// Sort out the debug logger
			$this->pdl = registry::register('plus_debug_logger');
			$this->pdl->register_type("morgdkp2", null, null, null, "morgdkp2.log");
			$this->pdl->log("morgdkp2", "Constructing class" );
			
			include_once(dirname(__FILE__).'/morgdkp2_functions.class.php');        
			$this->func = register('morgdkp2_functions');
		}
		
		public function parse($strLog){
		
			$this->pdl->log("morgdkp2", "Starting parsing ...");  
			$temp = $this->xmlstringtoarray($strLog);
			//$this->pdl->log("morgdkp2", 'DKP array:',$this->pdl->format_array($temp));
			$temp = $this->stripslashes_deep($temp);      
			$this->DKP = $temp['MorgDKP2'];
			$this->pdl->log("morgdkp2", 'DKP string:'.$this->pdl->format_array($this->DKP));
			
			if ($this->DKP['version'] != $this->webversion) {
				// Error return false
				return false;
			} else {
				foreach ($this->DKP as $eventtype => $table) {
					switch ($eventtype) {
						case 'Aliases':
							$this->addAliases($table);
							break;
						case 'DKPChanges':
							$this->changeDKP($table);
							break;
						case 'Raids':                
							$this->addRaids($table);
							$this->pdl->log("morgdkp2", 'Raid:',$this->pdl->format_array($this->RAID)); 
							$this->pdl->log("morgdkp2", 'Raid session:',$this->pdl->format_array($_SESSION['RAID'])); 
							break;
					}
				}
			}


			/*
			if ($objLog = json_decode($strLog)){
			$strTime = $this->time->date("Y-m-d H:i", intval($objLog->timestamp));
			$intTime = intval($objLog->timestamp);
			$arrRaidList = $this->pdh->get('raid', 'raididsindateinterval', array($intTime, 9999999999));
			foreach($arrRaidList as $raidid){
			$strNote = $this->pdh->get('raid', 'note', array($raidid));
			if (strpos($strNote, "EPGP-Snapshot") ===0){
			return false;
			}
			}
			
			
			//Build itemList
			$blnRaidItemList = false;
			$arrItemMembernameList = array();
			$arrItemMemberList = array();
			$arrItemList = array();
			foreach($objLog->loot as $objLootItem){
			//Try to check if item was imported, but how? When editing the raid, the item date will be the one from the raid
			//Get all raids between first item and now, and try to find the item with same name, value and buyer
			if ($blnRaidItemList === false){
			$intTmpTime = $objLootItem[0];
			$arrRaidList = $this->pdh->get('raid', 'raididsindateinterval', array($intTmpTime, 9999999999));
			foreach($arrRaidList as $raidid){
			$arrRaidItems = $this->pdh->get('item', 'itemsofraid', array($raidid));
			foreach($arrRaidItems as $itemid){
			$strBuyerName = $this->pdh->get('item', 'buyer_name', array($itemid));
			$arrItemMembernameList[$strBuyerName][] = array(
			'gameid'	=> (int)$this->pdh->get('item', 'game_itemid', array($itemid)),
			'value'		=> (float)$this->pdh->get('item', 'value', array($itemid)),
			);
			}
			}
			$blnRaidItemList = true;
			}
			
			$strBuyerName = $objLootItem[1];
			if (isset($arrItemMembernameList[$strBuyerName])){
			$blnNotThere = true;
			foreach($arrItemMembernameList[$strBuyerName] as $value){
			$intGameID = intval($objLootItem[2]);
			$floatValue = (float)$objLootItem[3];
			
			if ($intGameID == $value['gameid'] && $floatValue == $value['value']){
			$blnNotThere = false;
			break;
			}
			}
			
			if ($blnNotThere){
			$arrItemList[] = array(
			'gameid' => intval($objLootItem[2]),
			'value'	 => (float)$objLootItem[3],
			'buyer'	 => $strBuyerName
			);
			$arrItemMemberList[$strBuyerName] += $floatValue; 
			}
			
			} else {
			$intGameID = intval($objLootItem[2]);
			$floatValue = (float)$objLootItem[3];
			$arrItemList[] = array(
			'gameid' => $intGameID,
			'value'	 => $floatValue,
			'buyer'	 => $strBuyerName
			);
			$arrItemMemberList[$strBuyerName] += $floatValue;
			}
			
			}
			
			//The members
			$arrMember = array();
			$arrAdjustment = array();
			foreach($objLog->roster as $objRosterItem){
			$strMembername = $objRosterItem[0];
			$floatEP = (float)$objRosterItem[1];
			$floatGP = (float)$objRosterItem[2];
			
			//Get MemberID, if none, create member
			$intMemberID = $this->pdh->get('member', 'id', array($strMembername));
			if (!$intMemberID){
			//create new Member
			$data = array(
			'name' 		=> $strMembername,
			'lvl' 		=> 0,
			'raceid'	=> 0,
			'classid'	=> 0,
			'rankid'	=> $this->pdh->get('rank', 'default', array()),
			);
			$intMemberID = $this->pdh->put('member', 'addorupdate_member', array(0, $data));
			$this->pdh->process_hook_queue();
			
			$floatCurrentEP = 0;
			$floatCurrentGP = 0;
			} else {
			$arrMDKPools = $this->pdh->get('event', 'multidkppools', array($intEventID));
			$intMultidkpID = $arrMDKPools[0];
			$floatCurrentEP = $this->pdh->get('epgp', 'ep', array($intMemberID, $intMultidkpID, false, false));
			$floatCurrentGP = $this->pdh->get('epgp', 'gp', array($intMemberID, $intMultidkpID, false, false));
			}
			
			$floatAdjustement = $floatEP - $floatCurrentEP;
			if ($floatAdjustement != 0){
			//create adjustment
			$arrAdjustment[] = array(
			'value' => $floatAdjustement,
			'member'=> $intMemberID,
			'reason'=> 'EP, Snapshot '.$strTime,
			);
			}
			$floatGPItem = $floatGP - $floatCurrentGP - ((isset($arrItemMemberList[$strMembername])) ? $arrItemMemberList[$strMembername] : 0);
			
			//create dummy GP Item
			$arrItem[] = array(
			'value' => (float)$floatGPItem,
			'name' => 'GP, Snapshot '.$strTime,
			'gameid' => 0,
			'member' => $intMemberID,
			);
			
			$arrMember[] = $intMemberID;
			}
			//d($arrAdjustment);
			
			//Create raid with value 0
			$raid_upd = $this->pdh->put('raid', 'add_raid', array($intTime, $arrMember, $intEventID, 'EPGP-Snapshot '.$strTime, 0));
			
			if ($raid_upd){
			//Add Adjustments
			foreach ($arrAdjustment as $adj){
			if ($adj['value'] == 0) continue;
			$adj_upd[] = $this->pdh->put('adjustment', 'add_adjustment', array($adj['value'], $adj['reason'], $adj['member'], $intEventID, $raid_upd, $intTime));
			}
			$itempoolid = 1;
			foreach ($arrItem as $item){
			if ($item['value'] == 0) continue;
			$item_upd[] = $this->pdh->put('item', 'add_item', array($item['name'], $item['member'], $raid_upd, $item['gameid'], $item['value'], $intItempoolID, $intTime));
			}
			//Add Items
			foreach ($arrItemList as $item){
			if ($item['value'] == 0) continue;
			$intMemberID = $this->pdh->get('member', 'id', array($item['buyer']));
			if ($intMemberID) {
			$item_upd[] = $this->pdh->put('item', 'add_item', array('', $intMemberID, $raid_upd, $item['gameid'], $item['value'], $intItempoolID, $intTime));
			} else {
			
			}
			}
			
			$this->pdh->process_hook_queue();
			return $raid_upd;
			}
			} */
			return true;
		}

		private function xmlstringtoarray($xml) {      
			$return = array(); 
			$stack = array();
			$list = array();
			preg_match_all("/<(.*?)>/", $xml, $opentag);
			preg_match_all("/>(.*?)</", $xml, $data);
			
			foreach($opentag[1] as $tagnum => $tagname) {
				if (preg_match("/\//", $tagname)) {
					if (preg_match("/\/key/", $tagname)) $tagname = preg_replace("/key/", "", $tagname);
						$list[] = array('tag'=>$tagname, 'data'=>'', 'status'=>"closed");
					} else {
						if (preg_match("/key/", $tagname)) $tagname = preg_replace("/key/", "", $tagname);
						if ($data[1][$tagnum] != '') {
							$list[] = array('tag'=>$tagname, 'data'=>$data[1][$tagnum], 'status'=>"complete");
						} else {
							$list[] = array('tag'=>$tagname, 'data'=>'', 'status'=>"open");
						}
					}
			}
			
			$lastclosed = "";
			foreach($list as $val) {
				if($val['status'] == "open") {
					array_push($stack, $val['tag']);
				} elseif($val['status'] == "closed") {
					if ($lastclosed != $val['tag']) {
						array_pop($stack);
						$lastclosed = "/" . $val['tag'];
					}
				} elseif($val['status'] == "complete") {
					array_push($stack, $val['tag']);
					$this->func->setArrayValue($return, $stack, $val['data']);
					array_pop($stack);
					$lastclosed = "/" . $val['tag'];
				}
			}
			return $return;
		}

	private function addRaids($raids) {
		global $RAID, $Switches;
		$i = 0;
		//$this->pdl->log("morgdkp2", 'Adding raids:',$this->pdl->format_array($raids));
		if (!empty($raids)) {
			foreach ($raids as $raid) {
				$RAID[$i]['zone'] = $raid['zone'];
				$RAID[$i]['date'] = $raid['date'];
				$RAID[$i]['eqdkp'] = $raid['eqdkp'];
				$RAID[$i]['pool'] = $raid['pool'];
				$RAID[$i]['prefix'] = $raid['prefix'];
				foreach ($raid['Attendees'] as $attend) {
					$name = $attend['name'];
					$RAID[$i]['attendees'][$name] = array('race'=>$attend['race'], 'class'=>$attend['class'], 'level'=>$attend['level']);
				}
				$eventindex = 0;
				$webevents = $this->func->FetchAllEvents($raid['eqdkp'], $raid['prefix']);
				if (isset($raid['Bosskills'])) {
					foreach ($raid['Bosskills'] as $boss) {
						$bossname = $boss['name'];
						$bossnote = $boss['note'];
						$attend = $boss['attendees'];
						$attend = $this->func->CheckAlias($attend, $raid['eqdkp'], $raid['prefix']);
						if (!empty($attend)) {
							asort($attend);
							$attend = array_unique($attend);
							$RAID[$i]['events'][$eventindex] = array('name'=>$bossname, 'note'=>$bossnote,'value'=>$boss['value'], 'time'=>$boss['time'], 'attendees'=>$attend, 'trash'=>$boss['trash'], 'index'=>$eventindex);
							$eventindex++;
						}
					}
				}
				$trashdone = false;
				if (isset($RAID[$i]['events'])) {
					foreach ($RAID[$i]['events'] as $event) {
						$trashcounter = 0;
						$lootnumber = 0;
						if (isset($raid['Loot'])) {
							foreach ($raid['Loot'] as $loot) {
								if ($event['note'] == $loot['Boss']) {
									$index = $event['index'];
									$isalias = $this->func->CheckAlias(array('0' => $loot['Player']), $raid['eqdkp'], $raid['prefix']);
									$loot['Player'] = $isalias[0];
									$RAID[$i]['loot'][$index][$lootnumber] = $loot;
									$lootnumber++;
								}
								if (!$trashdone and $loot['Boss'] == "Trash mob") {
									$isalias = $this->func->CheckAlias(array('0' => $loot['Player']), $raid['eqdkp'], $raid['prefix']);
									$loot['Player'] = $isalias[0];
									$RAID[$i]['loot']['Trash mob'][$trashcounter] = $loot;
									$trashcounter++;
								}
							}
							$trashdone = true;
						}
					}     
					$i++;
				}
			}
			if (!empty($RAID)) {
				$_SESSION['RAID'] = $RAID;
				$Switches['raids'] = true;
			}    
		} 
	}



	private function stripslashes_deep($value) {
		$value = is_array($value) ? array_map(array('morgdkp2_parser','stripslashes_deep'), $value) :  stripslashes($value);
		return $value;
	}
    
	private function addAliases($aliases) {
		if (!empty($aliases)) {
			foreach ($aliases as $table) {
				$main = $table['main'];
				$alt = $table['alt'];
				print("FetchMember:".$table['eqdkp'].",". $table['prefix'].",".$main."<br/>");
				$memberid = $this->func->FetchMember($table['eqdkp'], $table['prefix'], $main);
				print ("Memberid:".$memberid. "<br/>");
				if ($memberid) {
					$this->newalts[] = array('alt'=>$alt, 'main'=>$main, 'eqdkp'=>$table['eqdkp'], 'pool'=>$table['pool'], 'prefix'=>$table['prefix'], 'id'=>$memberid, 'action'=>$table['action']);
					$this->Switches['alias'] = true;
				} else {
					$this->newalts[] = array('alt'=>$alt, 'main'=>$main, 'eqdkp'=>$table['eqdkp'], 'pool'=>$table['pool'], 'prefix'=>$table['prefix'], 'id'=>$memberid, 'action'=>'NO MAIN!');
					$this->Switches['alias'] = true;
				}
			}
		}
		if (!empty($this->newalts)) $_SESSION['passalts'] = $newalts;
	} // End of addAlias()

	private function changeDKP($changes) {
		global $needchanged, $Switches;
		if (!empty($changes)) {
			foreach ($changes as $change) {
				$name = $change['name'];
				$members = array();            
				foreach ($change['members'] as $memberkey => $member) {
					$members[$memberkey] = $member;
				}
				$members = CheckAlias($members, $change['eqdkp'], $change['prefix']);
				$needchanged[] = array('addtype'=>$change['addtype'], 'name'=>$name, 'value'=>$change['value'], 'eqdkp'=>$change['eqdkp'], 'pool'=>$change['pool'], 'prefix'=>$change['prefix'], 'event'=>$change['event'], 'members'=>$members);
			}
		}
		if (!empty($needchanged)) {
			$_SESSION['dkpchange'] = $needchanged;
			$Switches['dkpchange'] = true;
		}
	} // End of changeDKP()
	
	public function getSwitches() {
		return $this->Switches;
	}



  } // End of morgdkp2_parser class
} // End of enclosing if

if(version_compare(PHP_VERSION, '5.3.0', '<')) {
	registry::add_const('short_epgp_parser', epgp_parser::$shortcuts);
}
?>